/* These are virtual key codes returned by the Apple Extended Keyboard II.
   Other keyboards mimic this behiavor. Some better than others.
*/

#define SDLK_ESCAPE         0x35
#define SDLK_F1             0x7A
#define SDLK_F2             0x78
#define SDLK_F3             0x63
#define SDLK_F4             0x76
#define SDLK_F5             0x60
#define SDLK_F6             0x61
#define SDLK_F7             0x62
#define SDLK_F8             0x64
#define SDLK_F9             0x65
#define SDLK_F10            0x6d
#define SDLK_F11            0x67
#define SDLK_F12            0x6f
#define SDLK_F13            0x69
#define SDLK_F14            0x6B
#define SDLK_F15            0x71
#define SDLK_PRINT          0x69
#define SDLK_SCROLLOCK      0x6B
#define SDLK_PAUSE          0x71
#define SDLK_POWER          0x7F
#define SDLK_BACKQUOTE      0x32
#define SDLK_1              0x12
#define SDLK_2              0x13
#define SDLK_3              0x14
#define SDLK_4              0x15
#define SDLK_5              0x17
#define SDLK_6              0x16
#define SDLK_7              0x1A
#define SDLK_8              0x1c
#define SDLK_9              0x19
#define SDLK_0              0x1d
#define SDLK_MINUS          0x1B
#define SDLK_EQUALS         0x18
#define SDLK_BACKSPACE      0x33
#define SDLK_INSERT         0x72
#define SDLK_HOME           0x73
#define SDLK_PAGEUP         0x74
#define SDLK_NUMLOCK        0x47
#define SDLK_KP_EQUALS      0x51
#define SDLK_KP_DIVIDE      0x4B
#define SDLK_KP_MULTIPLY    0x43
#define SDLK_TAB            0x30
#define SDLK_q              0x0C
#define SDLK_w              0x0D
#define SDLK_e              0x0E
#define SDLK_r              0x0F
#define SDLK_t              0x11
#define SDLK_y              0x10
#define SDLK_u              0x20
#define SDLK_i              0x22
#define SDLK_o              0x1F
#define SDLK_p              0x23
#define SDLK_LEFTBRACKET    0x21
#define SDLK_RIGHTBRACKET   0x1E
#define SDLK_BACKSLASH      0x2A
#define SDLK_DELETE         0x75
#define SDLK_END            0x77
#define SDLK_PAGEDOWN       0x79
#define SDLK_CAPSLOCK       0x39
#define SDLK_a              0x00
#define SDLK_s              0x01
#define SDLK_d              0x02
#define SDLK_f              0x03
#define SDLK_g              0x05
#define SDLK_h              0x04
#define SDLK_j              0x26
#define SDLK_k              0x28
#define SDLK_l              0x25
#define SDLK_SEMICOLON      0x29
#define SDLK_QUOTE          0x27
#define SDLK_RETURN         0x24
#define SDLK_LSHIFT         0x38
#define SDLK_z              0x06
#define SDLK_x              0x07
#define SDLK_c              0x08
#define SDLK_v              0x09
#define SDLK_b              0x0B
#define SDLK_n              0x2D
#define SDLK_m              0x2E
#define SDLK_COMMA          0x2B
#define SDLK_PERIOD         0x2F
#define SDLK_SLASH          0x2C
#define SDLK_RSHIFT         0x38
#define SDLK_UP             0x7E
#define SDLK_LCTRL          0x3B
#define SDLK_LALT           0x3A
#define SDLK_LMETA          0x37
#define SDLK_SPACE          0x31
#define SDLK_RMETA          0x37
#define SDLK_RALT           0x3A
#define SDLK_RCTRL          0x3B
#define SDLK_LEFT           0x7B
#define SDLK_DOWN           0x7D
#define SDLK_RIGHT          0x7C
#define SDLK_KP0            0x52
#define SDLK_KP1            0x53
#define SDLK_KP2            0x54
#define SDLK_KP3            0x55
#define SDLK_KP4            0x56
#define SDLK_KP5            0x57
#define SDLK_KP6            0x58
#define SDLK_KP7            0x59
#define SDLK_KP8            0x5b
#define SDLK_KP9            0x5c
#define SDLK_KP_PERIOD      0x41
#define SDLK_KP_MINUS       0x4E
#define SDLK_KP_PLUS        0x45
#define SDLK_KP_ENTER       0x4C


/* These keys do not have codes. On the macintosh they are created by using
   a modifier key (control, shift, option) with one of the above keys.
*/
#define SDLK_CLEAR          0x00
#define SDLK_EXCLAIM        0x00
#define SDLK_QUOTEDBL       0x00
#define SDLK_HASH           0x00
#define SDLK_DOLLAR         0x00
#define SDLK_AMPERSAND      0x00
#define SDLK_LEFTPAREN      0x00
#define SDLK_RIGHTPAREN     0x00
#define SDLK_ASTERISK       0x00
#define SDLK_COLON          0x00
#define SDLK_LESS           0x00
#define SDLK_GREATER        0x00
#define SDLK_QUESTION       0x00
#define SDLK_AT             0x00
#define SDLK_CARET          0x00
#define SDLK_UNDERSCORE     0x00
#define SDLK_PLUS           0x00
#define SDLK_LSUPER         0x00
#define SDLK_RSUPER         0x00
#define SDLK_MODE           0x00
#define SDLK_HELP           0x00
#define SDLK_SYSREQ         0x00
#define SDLK_BREAK          0x00
#define SDLK_MENU           0x00
#define SDLK_EURO           0x00
#define SDLK_WORLD_0        0x00
#define SDLK_WORLD_1        0x00
#define SDLK_WORLD_2        0x00
#define SDLK_WORLD_3        0x00
#define SDLK_WORLD_4        0x00
#define SDLK_WORLD_5        0x00
#define SDLK_WORLD_6        0x00
#define SDLK_WORLD_7        0x00
#define SDLK_WORLD_8        0x00
#define SDLK_WORLD_9        0x00
#define SDLK_WORLD_10       0x00
#define SDLK_WORLD_11       0x00
#define SDLK_WORLD_12       0x00
#define SDLK_WORLD_13       0x00
#define SDLK_WORLD_14       0x00
#define SDLK_WORLD_15       0x00
#define SDLK_WORLD_16       0x00
#define SDLK_WORLD_17       0x00
#define SDLK_WORLD_18       0x00
#define SDLK_WORLD_19       0x00
#define SDLK_WORLD_20       0x00
#define SDLK_WORLD_21       0x00
#define SDLK_WORLD_22       0x00
#define SDLK_WORLD_23       0x00
#define SDLK_WORLD_24       0x00
#define SDLK_WORLD_25       0x00
#define SDLK_WORLD_26       0x00
#define SDLK_WORLD_27       0x00
#define SDLK_WORLD_28       0x00
#define SDLK_WORLD_29       0x00
#define SDLK_WORLD_30       0x00
#define SDLK_WORLD_31       0x00
#define SDLK_WORLD_32       0x00
#define SDLK_WORLD_33       0x00
#define SDLK_WORLD_34       0x00
#define SDLK_WORLD_35       0x00
#define SDLK_WORLD_36       0x00
#define SDLK_WORLD_37       0x00
#define SDLK_WORLD_38       0x00
#define SDLK_WORLD_39       0x00
#define SDLK_WORLD_40       0x00
#define SDLK_WORLD_41       0x00
#define SDLK_WORLD_42       0x00
#define SDLK_WORLD_43       0x00
#define SDLK_WORLD_44       0x00
#define SDLK_WORLD_45       0x00
#define SDLK_WORLD_46       0x00
#define SDLK_WORLD_47       0x00
#define SDLK_WORLD_48       0x00
#define SDLK_WORLD_49       0x00
#define SDLK_WORLD_50       0x00
#define SDLK_WORLD_51       0x00
#define SDLK_WORLD_52       0x00
#define SDLK_WORLD_53       0x00
#define SDLK_WORLD_54       0x00
#define SDLK_WORLD_55       0x00
#define SDLK_WORLD_56       0x00
#define SDLK_WORLD_57       0x00
#define SDLK_WORLD_58       0x00
#define SDLK_WORLD_59       0x00
#define SDLK_WORLD_60       0x00
#define SDLK_WORLD_61       0x00
#define SDLK_WORLD_62       0x00
#define SDLK_WORLD_63       0x00
#define SDLK_WORLD_64       0x00
#define SDLK_WORLD_65       0x00
#define SDLK_WORLD_66       0x00
#define SDLK_WORLD_67       0x00
#define SDLK_WORLD_68       0x00
#define SDLK_WORLD_69       0x00
#define SDLK_WORLD_70       0x00
#define SDLK_WORLD_71       0x00
#define SDLK_WORLD_72       0x00
#define SDLK_WORLD_73       0x00
#define SDLK_WORLD_74       0x00
#define SDLK_WORLD_75       0x00
#define SDLK_WORLD_76       0x00
#define SDLK_WORLD_77       0x00
#define SDLK_WORLD_78       0x00
#define SDLK_WORLD_79       0x00
#define SDLK_WORLD_80       0x00
#define SDLK_WORLD_81       0x00
#define SDLK_WORLD_82       0x00
#define SDLK_WORLD_83       0x00
#define SDLK_WORLD_84       0x00
#define SDLK_WORLD_85       0x00
#define SDLK_WORLD_86       0x00
#define SDLK_WORLD_87       0x00
#define SDLK_WORLD_88       0x00
#define SDLK_WORLD_89       0x00
#define SDLK_WORLD_90       0x00
#define SDLK_WORLD_91       0x00
#define SDLK_WORLD_92       0x00
#define SDLK_WORLD_93       0x00
#define SDLK_WORLD_94       0x00
#define SDLK_WORLD_95       0x00

#define SDLK_LAST           0xff
